#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "sock.h"
#define SEND 1
#define RECV 0
extern  GtkWidget *playlist_clist;  
extern GtkWidget *PlayBrowse;
extern GtkWidget *MainWindow;
extern GtkWidget *PlayBrowse;
extern GtkWidget *PrefsWindow;
extern GtkWidget *AboutWindow;
extern GtkWidget *SearchWindow;
extern gboolean SearchWindow_disp;
extern gboolean  AboutWindow_disp;
extern gboolean  PrefsWindow_disp;
extern gboolean  PlayBrowse_disp;
extern gchar *parent_dir;
extern gchar *current_dir;
extern gint current_vol;
extern gint status_id;
extern int main_sock;
extern int status_sock;
extern GList *playlist_glist;
extern gchar* send_cmd(char *dir);
extern gboolean setting_vol;
extern gint   pl_filecount;
extern struct _prefs *prefs;
extern gboolean update_status(gpointer data);
extern struct file_info* parse_dir(gchar **line_tmp,gint file_count);
extern void do_search(gchar *option,gchar *data);
extern void command_list_start();
extern void command_list_end();
extern void fill_savedpl();
extern gboolean sock_mutex;
extern void save_config();
extern gchar * mpd_sanitizePath(gchar * path);
extern gboolean keep_alive(gpointer data);
extern gboolean sock_mutex;
extern gboolean keep_mutex;
gint row_playing=-1;
GtkWidget *error=NULL;
guint to_update_status=0;
guint to_keep_alive=0;

void del_wid_data(struct widget_data* data)
{
	g_free(data->data[0][0]);
	g_free(data->path);
	g_free(data);
}
gint
get_glistbyrow(gconstpointer *list_item, gint row)
{
	const struct file_info *fi;
	fi=(struct file_info*)list_item;
	if(fi->row==row)
		return 0;
	else
		return 1;
}

void show_error(gchar *text)
{
	GtkWidget  *text_view;
	GtkTextBuffer *buffer;
	if(error) gtk_widget_destroy(error);
	error=create_error_dialog();
	text_view=lookup_widget (GTK_WIDGET(error),"error_textview");

	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
	gtk_text_buffer_set_text(buffer,text,-1);
	gtk_text_view_set_buffer((GtkTextView*)text_view,buffer);
	gtk_widget_show(error);
}
gint show_ret(gchar *ret)
{
	if(!ret)
	{
		show_error("Not Connected");
		return 0;
	}
	else
  		if((ret[0]=='A' && ret[1]=='C' && ret[2]=='K') )
  		{
  			show_error(ret);
			return 0;
  		}
	return 1;
}
void set_clist_bg(GtkWidget *clist,gint row,gchar *color)
{
	GdkColor	 fcolor;
    GdkColormap	 *fcmap;

	fcmap = gdk_colormap_get_system();
	gdk_color_parse(color,&fcolor);
    if (!gdk_color_alloc(fcmap, &fcolor)) {
    	g_error("play_file_cb::couldn't allocate color");
    }
	else
		gtk_clist_set_background((GtkCList *)clist,row,&fcolor);
}
void
play_file_cb				(GtkWidget *widget, gint row, gint column,
					     	GdkEventButton *event, gpointer data)
{
	GList *list;
	gchar *cmd;
	GtkWidget 	 *playlist_clist;
	struct file_info *fi;
	gchar *ret;
	
	if(event && (event->button == 1)) 
	{
		if(event->type == GDK_2BUTTON_PRESS) 
		{
			list=g_list_find_custom(playlist_glist,(gpointer)row,(GCompareFunc)get_glistbyrow);
			if(list)
			{
				playlist_clist	=lookup_widget (GTK_WIDGET(PlayBrowse), "playlist_clist");
				fi=(struct file_info*)list->data;
				myprint("play_file_cb::Row clicked=%i\n",fi->row);
				cmd=g_strdup_printf("play %i\n",row);
				ret=send_cmd(cmd);
				g_free(cmd);
				if(show_ret(ret))
				{
					set_file_playing(row);
					g_free(ret);
				}
			}
			else 
			{	
				myprint("play_file_cb::BUG: contact author\n");
			}
			return;
		}
	}
	else 
	    return;
}

void
dir_list_cb				(GtkWidget *widget, gint row, gint column,
					     GdkEventButton *event, gpointer data)
{
	gchar 	  *dir_name;
	GtkList   *dir_list;
	gchar     *parent_tmp;
	gchar     *path_tmp;
	gchar     *cmd;
	gchar     *cmd_tmp;
	int len;
	int cont=0;
	struct widget_data *wid_data=0;
	if(event && (event->button == 1)) 
	{
		if(event->type == GDK_2BUTTON_PRESS) 
		{
			
			wid_data=gtk_clist_get_row_data (GTK_CLIST(widget),row);
			if(wid_data)
			{
				path_tmp=wid_data->path;
				len=strlen(path_tmp);
				myprint("path=%s\n",path_tmp);
					
				if(!strcmp(path_tmp,"directory: ROOT") && !strcmp(current_dir,"ROOT"))
					return;
						
				while(path_tmp[0]!=' ' && len-- && path_tmp[len]!='/');
				if(len>0)	//we got a subdir
				{
					
					if(parent_dir)
						g_free(parent_dir);
					parent_dir=g_convert (path_tmp,len, "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
				}
				else
				{
					if(parent_dir)
						g_free(parent_dir);
					parent_dir=g_strdup("directory: ROOT");
				}
				if(current_dir)
					g_free(current_dir);
				current_dir=g_convert (wid_data->path+11,strlen(wid_data->path+11), "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
				
				if(!strcmp(wid_data->path,"directory: ROOT"))
					cmd_tmp=g_strdup("");
				else
					cmd_tmp=mpd_sanitizePath(wid_data->path+11);
				cmd=g_strdup_printf("lsinfo \"%s\"\n",cmd_tmp);
				g_free(cmd_tmp);
				fill_dir(cmd);
				g_free(cmd);
			}
			else 
			{
				if(current_dir)
					g_free(current_dir);
				current_dir=g_strdup(" ");
				fill_dir("lsinfo\n");
			}
			return;
			
		}
	}
	else 
	    return;
}
void
file_add_pl	(GtkWidget *widget, gint row, gint column,
					     GdkEventButton *event, gpointer data)
{
	gchar     *cmd;
	gchar     *ret;
	gchar     *path;
	struct file_info *fi;
	if(event && (event->button == 1)) 
	{
		if(event->type == GDK_2BUTTON_PRESS) 
		{
			  fi=(struct file_info*)gtk_clist_get_row_data (GTK_CLIST(widget),row);
  			  path=mpd_sanitizePath(fi->file_path);
			  
			  cmd=g_strdup_printf("add \"%s\"\n",path);
			  g_free(path);
  			  ret=send_cmd(cmd);
  			  g_free(cmd);
			  if(show_ret(ret))
					g_free(ret);
		}
	}


}
dir_add_pl (GtkButton *button, gpointer user_data)
{
	gchar *cmd;
	gchar *cmd_tmp;
	gchar *path;
	gchar *ret;
	gint  i=0;
	gint  line_len=0;
	gint  len=0;
	gchar **line_tmp;
	
	sock_mutex=TRUE;
	path=mpd_sanitizePath((gchar*)user_data);
	cmd=g_strdup_printf("listall \"%s\"\n",path);
	g_free(path);

	ret=send_cmd(cmd);
	g_free(cmd);
	
	for(i=0;i<len;i++)
	    if(ret[i]=='\n') line_len++;
    line_tmp=g_strsplit(ret,"\n",line_len);
    g_free(ret);
    i=0;

	command_list_begin();
	while(line_tmp[i]!='\0')
    {	
	    if(line_tmp[i] && strstr(line_tmp[i],"file:"))
	    {
			gchar *cmd;
			gchar *ret;
			cmd_tmp=mpd_sanitizePath(line_tmp[i]+6);
			cmd=g_strdup_printf("add \"%s\"\n",cmd_tmp);
			g_free(cmd_tmp);
			send_recv(main_sock,cmd ,strlen(cmd),SEND);
			g_free(cmd);
		}
		i++;
	}
	command_list_end();
	g_strfreev(line_tmp);
	sock_mutex=FALSE;
}
void
on_next_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	gint row;

	cmd=g_strdup_printf("next\n");
    ret=send_cmd(cmd);
	g_free(cmd);
	if(show_ret(ret))
		g_free(ret);
	
}


void
on_stop_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	    cmd=g_strdup("stop\n");
	    ret=send_cmd(cmd);
		g_free(cmd);
	if(show_ret(ret))
		g_free(ret);
	
}


void
on_pause_btn_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;

    cmd=g_strdup("pause\n");
    ret=send_cmd(cmd);
	g_free(cmd);
	if(show_ret(ret))
		g_free(ret);
}


void
on_play_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
GList * Selection;
gint row;
gchar *ret;
gchar *cmd;

	Selection = GTK_CLIST(playlist_clist)->selection;   /*get the list with selected rows*/
	if (Selection != NULL)  /*if selection == NULL then no row was selected*/
	{
    	row = (gint)Selection->data;
	}
	else
		if(pl_filecount)
			row=0;
		else
			row=-1;
		
		if(row!=-1)
		{
	    	cmd=g_strdup_printf("play %i\n",row);
	    	ret=send_cmd(cmd);
			g_free(cmd);
			if(show_ret(ret))
				g_free(ret);
			else 
				set_file_playing(row);
		}
	
}


void
on_prev_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	gint row;
	cmd=g_strdup_printf("previous\n");
    ret=send_cmd(cmd);
	g_free(cmd);
	if(show_ret(ret))
			g_free(ret);
	
}


void
on_addsel_btn_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{    
	GList *sList;
    gint row;
	GtkWidget *files_clist;
	struct file_info *fi;
	gchar *cmd;
	gchar *cmd_tmp;
	
	files_clist = lookup_widget (GTK_WIDGET (PlayBrowse), "files_clist");
    sList = GTK_CLIST(files_clist)->selection;
    command_list_begin(); 
	while(sList){
          row = (gint) sList->data;
          sList = sList->next;
		
		 fi=(struct file_info*)gtk_clist_get_row_data (GTK_CLIST(files_clist),row);
  		 cmd_tmp=mpd_sanitizePath(fi->file_path);
		 cmd=g_strdup_printf("add \"%s\"\n",cmd_tmp);
		 g_free(cmd_tmp);
  		 send_recv(main_sock,cmd ,strlen(cmd),SEND);
  		 g_free(cmd);
	 }
	 command_list_end();
}


void
on_addall_btn_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	dir_add_pl(NULL,current_dir);
}


void
on_clear_btn_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	cmd=g_strdup("clear\n");
  	ret=send_cmd(cmd);
  	g_free(cmd);
	if(show_ret(ret))
		g_free(ret);
}


void
on_save_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *playlist_entry;
	gchar *data;
	
	playlist_entry = lookup_widget (GTK_WIDGET (PlayBrowse), "playlist_entry");
	data=gtk_editable_get_chars(GTK_EDITABLE(playlist_entry),0,-1);
	myprint("plname=%s\n",data);
}


void
on_shufle_btn_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	cmd=g_strdup("shuffle\n");
  	ret=send_cmd(cmd);
  	g_free(cmd);
	  
	if(show_ret(ret))
		g_free(ret);
}


void
on_search_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(SearchWindow_disp==FALSE)
	{
		gtk_widget_show(SearchWindow);
		SearchWindow_disp=TRUE;
	}
	else
	{
		gtk_widget_hide(SearchWindow);
		SearchWindow_disp=FALSE;
	}
}


void
on_updatedb_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	GtkWidget *update_window;
	update_window=create_update_window();
	gtk_widget_show(update_window);
	while (gtk_events_pending ())
    		gtk_main_iteration();
	cmd=g_strdup("update\n");
    ret=send_cmd(cmd);
	g_free(cmd);
	if(show_ret(ret))
	{
			g_free(ret);
	}
	gtk_widget_destroy(update_window);
	
}


void
on_exit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	on_MainWindow_destroy_event(NULL,NULL,NULL);
}


void
on_preferences_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(PrefsWindow_disp==FALSE)
	{
		gtk_widget_show(PrefsWindow);
		PrefsWindow_disp=TRUE;
	}
}


void
on_connect_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *statusbar1;
	statusbar1 = lookup_widget (GTK_WIDGET (MainWindow), "statusbar1");

	if(main_sock==0)
	{
		main_sock=my_connect();
		if(main_sock)
		{
			g_free(send_cmd("status\n"));//get the banner
			fill_dir("lsinfo\n");
			fill_playlist ();
			fill_savedpl();
			row_playing=-1;
			to_keep_alive=gtk_timeout_add (30000,
			 				(GtkFunction) keep_alive, NULL);
			gtk_statusbar_pop(GTK_STATUSBAR(statusbar1),status_id);
    		gtk_statusbar_push(GTK_STATUSBAR(statusbar1),status_id,_("Connected"));
		}
		status_sock= my_connect();
		if(status_sock)
		{
			to_update_status=gtk_timeout_add (prefs->refresh,
				 			(GtkFunction) update_status, NULL);
		}


	}
	else show_error("Already Connected");
}


void
on_disconnect_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *statusbar1;
	GtkWidget	*text_view;
	GtkTextBuffer *buffer;
	if(main_sock)
	{	
		statusbar1 = lookup_widget (GTK_WIDGET (MainWindow), "statusbar1");
		text_view=lookup_widget (GTK_WIDGET(MainWindow),"file_playing_textview");
		
		gtk_timeout_remove(to_keep_alive);
		gtk_timeout_remove(to_update_status);
		keep_mutex=FALSE;
		sock_mutex=FALSE;
		close(main_sock);
		main_sock=0;
		close(status_sock);
		status_sock=0;
		
		buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
		gtk_text_buffer_set_text(buffer," ",-1);
		gtk_text_view_set_buffer((GtkTextView*)text_view,buffer);
		gtk_statusbar_pop(GTK_STATUSBAR(statusbar1),status_id);
    	gtk_statusbar_push(GTK_STATUSBAR(statusbar1),status_id,_("Disconnected"));
	}

}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	if(AboutWindow_disp==FALSE)
	{
		gtk_widget_show(AboutWindow);
		AboutWindow_disp=TRUE;
	}
}


void
on_mute_btn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_unmute_btn_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_playlist_btn_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	if(main_sock)
	{
		if(PlayBrowse_disp==FALSE)
		{
			gtk_widget_show (PlayBrowse);
			PlayBrowse_disp=TRUE;
		}
		else
		{
			PlayBrowse_disp=FALSE;
			gtk_widget_hide(PlayBrowse);
		}
	}
	else show_ret(0);
		
}

void
on_error_okbtn_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	if(error)
	{
		gtk_widget_destroy(error);
		error=NULL;
	}
}

void
on_refresh_btn_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	fill_playlist();
	set_file_playing(row_playing);
}

gboolean
on_PlayBrowse_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	on_playlist_btn_clicked(NULL,NULL);
  return TRUE;
}

void
on_hideplaylist_btn_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
		if(PlayBrowse_disp=TRUE)
		{
			PlayBrowse_disp=FALSE;
			gtk_widget_hide(PlayBrowse);
		}
}

void
on_vol_scale_value_changed             (GtkRange        *range,
                                        gpointer         user_data)
{
	GtkAdjustment *adj;
	gchar *ret;	
	gchar *cmd;
	gint vol=0;
	setting_vol=TRUE;
	adj=gtk_range_get_adjustment(range);

	vol=((gint)adj->value)-(current_vol);
	if(current_vol!=vol)
	{
		cmd=g_strdup_printf("volume %i\n",vol);
		ret=send_cmd(cmd);
		g_free(cmd);
		if(show_ret(ret))
		{
			g_free(ret);
		}
	}
	setting_vol=FALSE;
  /*GtkWidget *vol_scale;
 
  gtk_scale_set_value_pos(GTK_SCALE(vol_scale), ((GtkAdjustment *)range)->value);*/
	
}

gboolean
on_MainWindow_destroy_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	on_prefs_ok_clicked(NULL,NULL);
	save_config();
	on_disconnect_activate(NULL,NULL);
	gtk_widget_destroy(PrefsWindow);
	gtk_widget_destroy(PlayBrowse);
	gtk_widget_destroy(AboutWindow);
	gtk_widget_destroy(SearchWindow);
	gtk_widget_destroy(MainWindow);
	gtk_main_quit();
	myprint("EXITING\n");
	return FALSE;
}
void
on_prefs_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkAdjustment *adj;
	GtkWidget *prefs_server;
	GtkWidget *prefs_port;
	GtkWidget *prefs_refresh;	
	GtkWidget *prefs_connect;
	GtkWidget *prefs_onlyfn;
	GtkWidget *prefs_songdisp;
	
	prefs_server=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_server");
	prefs_songdisp=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_songdisp");
	
	prefs_port=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_port");
	prefs_refresh=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_refresh");
	prefs_connect=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_connect");
	prefs_onlyfn=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_onlyfn");
	g_free(prefs->server);
	g_free(prefs->songdisp);
	
	prefs->server=gtk_editable_get_chars(GTK_EDITABLE(prefs_server),0,-1);
	prefs->songdisp=gtk_editable_get_chars(GTK_EDITABLE(prefs_songdisp),0,-1);
	prefs->port=(gint)atoi(gtk_editable_get_chars(GTK_EDITABLE(prefs_port),0,-1));
	
	prefs->refresh=(gint)gtk_spin_button_get_value((GtkSpinButton*)prefs_refresh);

	prefs->auto_connect=(gint)gtk_toggle_button_get_active((GtkToggleButton *)prefs_connect);
	prefs->onlyfn=(gint)gtk_toggle_button_get_active((GtkToggleButton *)prefs_onlyfn);
	myprint("onlfn=%i\n",prefs->onlyfn);
	fill_playlist();
	set_file_playing(row_playing);
	on_prefs_cancel_clicked(NULL,NULL);
}


void
on_prefs_cancel_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	if(PrefsWindow_disp!=FALSE)
	{
		gtk_widget_hide(PrefsWindow);
		PrefsWindow_disp=FALSE;
	}
}

gboolean
on_prefs_window_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	on_prefs_cancel_clicked(NULL,NULL);
	return TRUE;
}

void
on_about_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	if(AboutWindow_disp==TRUE)
	{
		gtk_widget_hide(AboutWindow);
		AboutWindow_disp=FALSE;
	}
}

void
on_pl_del_btn_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
  	GList *tmp;
	gint  row_delete=0;
	gint  cont=0;
  	sock_mutex=TRUE;
		for (tmp = GTK_CLIST(playlist_clist)->selection; tmp; tmp = tmp->next)
		{
			
			row_delete=GPOINTER_TO_UINT(tmp->data)-cont;
			if(row_delete<0)
				row_delete=0;
			cmd=g_strdup_printf("delete %i\n",row_delete);
  			ret=send_cmd(cmd);
  			if(show_ret(ret))
			{
		  		if((ret[0]=='A' && ret[1]=='C' && ret[2]=='K') )
  				{
					myprint("ERROR:%s\ncmd=%s",ret,cmd);
				}
				g_free(ret);
			}
  			g_free(cmd);
			cont++;
		}
	sock_mutex=FALSE;
}

void
on_search_addsel_btn_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	GList *sList;
    gint row;
	GtkWidget *files_clist;
	struct file_info *fi;
	gchar *cmd;
	gchar *cmd_tmp;
	files_clist = lookup_widget (GTK_WIDGET (PlayBrowse), "search_clist");
    sList = GTK_CLIST(files_clist)->selection;
    command_list_begin(); 
	while(sList){
          row = (gint) sList->data;
          sList = sList->next;
		
		 fi=(struct file_info*)gtk_clist_get_row_data (GTK_CLIST(files_clist),row);
		 cmd_tmp=mpd_sanitizePath(fi->file_path);
  		 cmd=g_strdup_printf("add \"%s\"\n",cmd_tmp);
		 g_free(cmd_tmp);
  		 send_recv(main_sock,cmd ,strlen(cmd),SEND);
  		 g_free(cmd);
	 }
	 command_list_end();
}


void
on_search_addall_btn_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	GList *sList;
    gint row=-1;
	GtkWidget *files_clist;
	struct file_info *fi;
	gchar *cmd;
	gchar *cmd_tmp;
	files_clist = lookup_widget (GTK_WIDGET (PlayBrowse), "search_clist");
    sList = GTK_CLIST(files_clist)->row_list;
    command_list_begin(); 
	while(sList){
          row++;// = (gint) sList->data;
          sList = sList->next;
		  myprint("ROW=%i\n",row);
		 fi=(struct file_info*)gtk_clist_get_row_data (GTK_CLIST(files_clist),row);
		 if(fi)
		 {
		 	cmd_tmp=mpd_sanitizePath(fi->file_path);
  		 	cmd=g_strdup_printf("add \"%s\"\n",cmd_tmp);
		 	g_free(cmd_tmp);
  		 	send_recv(main_sock,cmd ,strlen(cmd),SEND);
  		 	g_free(cmd);
		 }
	 }
	 command_list_end();

}

gboolean
on_search_window_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	on_search_activate(NULL,NULL);
  return TRUE;
}

void
on_search_cancel_btn_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	on_search_activate(NULL,NULL);
}


void
on_sarch_ok_btn_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *search_options;
	GtkEntry  *entry_options;
	GtkWidget *search_data;
	GtkWidget *main_notebook;
	gchar *data;
	gchar *option;
	search_options =
		lookup_widget (GTK_WIDGET (SearchWindow), "search_options");
	search_data =
		lookup_widget (GTK_WIDGET (SearchWindow), "search_data");
	main_notebook=
		lookup_widget (GTK_WIDGET (PlayBrowse), "main_notebook");

	data=gtk_editable_get_chars(GTK_EDITABLE(search_data),0,-1);
	option=gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(search_options)->entry),0,-1);
	
	myprint("DATA=%s OPTION=%s\n",data,option);
	
	do_search(option,data);
	on_search_activate(NULL,NULL);
	if(PlayBrowse_disp==FALSE)
	{
		gtk_widget_show(PlayBrowse);
		PlayBrowse_disp=TRUE;
	}
	gtk_notebook_set_current_page(GTK_NOTEBOOK(main_notebook),1);
	gdk_window_raise (PlayBrowse->window);

}

void
on_bp_search_btn_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{	
	GtkWidget *bp_search_combo;
	GtkWidget *bp_search_entry;
	gchar *data;
	gchar *option;
	
	bp_search_combo =
		lookup_widget (GTK_WIDGET (PlayBrowse), "bp_search_combo");
	bp_search_entry  =
		lookup_widget (GTK_WIDGET (PlayBrowse), "bp_search_entry");
	
	data=gtk_editable_get_chars(GTK_EDITABLE(bp_search_entry),0,-1);
	option=gtk_editable_get_chars(GTK_EDITABLE(GTK_COMBO(bp_search_combo)->entry),0,-1);
	do_search(option,data);
}

void
on_delete_savedpl_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *cmd;
	gchar *ret;
	gchar *name;
  	GList *tmp;
	gint  row=0;
	GtkWidget *playlist_clist;
	
	playlist_clist	=lookup_widget (GTK_WIDGET(PlayBrowse), "savedpl_clist");
	
	
	for (tmp = GTK_CLIST(playlist_clist)->selection; tmp; tmp = tmp->next)
		{
			
			row=GPOINTER_TO_UINT(tmp->data);
			if(row<0)
				row=0;
			name=gtk_clist_get_row_data(GTK_CLIST(playlist_clist),row);
			myprint("row=%i name=%s",row,name);
			cmd=g_strdup_printf("rm \"%s\"\n",name);
  			ret=send_cmd(cmd);
  			if(show_ret(ret))
			{
				g_free(ret);
			}
  			g_free(cmd);
		}
	fill_savedpl();

}


void
on_save_savedpl_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *savedpl_entry;
	G_CONST_RETURN gchar *name;
	gchar *ret,*cmd;
	
	savedpl_entry=lookup_widget (GTK_WIDGET(PlayBrowse), "savedpl_entry");
	name=gtk_entry_get_text(GTK_ENTRY(savedpl_entry));

	myprint("saved playlist name=%s",name);
	cmd=g_strdup_printf("save \"%s\"\n",name);
	ret=send_cmd(cmd);
	
	if(show_ret(ret))
	{
		g_free(ret);
		fill_savedpl();
		gtk_entry_set_text(GTK_ENTRY(savedpl_entry),"");
	}
	g_free(cmd);

}


void
on_load_savedpl_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *playlist_clist;
	gchar *cmd;
	gchar *ret;
  	gchar *name;
	GList *tmp;

	playlist_clist	=lookup_widget (GTK_WIDGET(PlayBrowse), "savedpl_clist");
	
	tmp = GTK_CLIST(playlist_clist)->selection; 
	
	name=gtk_clist_get_row_data(GTK_CLIST(playlist_clist),GPOINTER_TO_UINT(tmp->data));
	myprint("name=%s row=%i",name,GPOINTER_TO_UINT(tmp->data));
	cmd=g_strdup_printf("load \"%s\"\n",name);
	ret=send_cmd(cmd);
	
	if(show_ret(ret))
		g_free(ret);
	g_free(cmd);
}


void
on_refresh_savedpl_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
	fill_savedpl();
}

void
on_savedpl_entry_activate              (GtkEntry        *entry,
                                        gpointer         user_data)
{
	on_save_savedpl_clicked  (NULL,NULL);
}
