#include <sys/stat.h>
#include <sys/types.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h> /* close */
#include <fcntl.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "interface.h"
#include "support.h"
#include "sock.h"
#include "callbacks.h"
#include "libcoman.h"
#define SEND 1
#define RECV 0
GList *dir_glist = NULL;
gint dir_rows=0;
gchar *parent_dir=NULL;
gchar *current_dir=NULL;
GList *playlist_glist = NULL;
struct file_info *fi_array=NULL; //array with file information
gint   fi_filecount=0; //count of files
struct file_info *pl_array=NULL; //array with file info in the playlist
gint   pl_filecount=0;
GList *savedpl_list=NULL; //array for the saved playlists
gint   savedpl_filecount=0; //total of saved playlists
struct file_info *search_array=NULL; //array with file info in the search result
gint   search_filecount=0;
extern struct _prefs *prefs;
extern GtkWidget *playlist_clist;  
extern GtkWidget *MainWindow;
extern GtkWidget *PrefsWindow;
extern GtkWidget *SearchWindow;
extern gint row_playing;
extern int main_sock;
extern int status_sock;
extern GtkWidget *PlayBrowse;
extern gchar *dirs[1][1];
extern gboolean keep_mutex;
extern gboolean DEBUG;
extern void del_wid_data(gpointer data);
extern void set_clist_bg(GtkWidget *clist,gint row,gchar *color);
extern gint get_glistbyrow(gconstpointer *list_item, gint row);
extern dir_add_pl (GtkButton *button, gpointer user_data);
extern void
on_disconnect_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
gchar* _send_cmd(char *dir,int sock);
gchar * mpd_sanitizePath(gchar * path);
/* Functions that doesnt use GTK
*/
int my_connect () {

    int sd, rc;
  struct sockaddr_in localAddr, servAddr;
  struct hostent *h;
  
  h = gethostbyname(prefs->server);
  if(h==NULL) {
    show_error("unknown host");
    return 0;
  }

  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0], h->h_length);
  servAddr.sin_port = htons(prefs->port);

  /* create socket */
  if ( (sd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    show_error("cannot open socket ");
    return 0;
  }
  /* bind any port number */
  localAddr.sin_family = AF_INET;
  localAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  localAddr.sin_port = htons(0);
  
				
  /* connect to server */
  rc = connect(sd, (struct sockaddr *) &servAddr, sizeof(servAddr));
  if(rc<0) {
    show_error("cannot connect ");
    return 0;
  }

  return sd; // returneamos el socket
}

int send_recv(int s, char *msg, int size,int que) /* 1= send 0=get*/
{
    int numbytes=0;
    int ret=0;
	
	// FIXME: seems to freeze the gui
	/*if(s==main_sock && keep_mutex==TRUE)
	{
		while(keep_mutex==TRUE)
	 	{ usleep(1); }; //wait till the mutex on main_sock is free
	}*/
	if(s)
	{
    	if(que==RECV)
    	{
			numbytes=recv(s, msg, size, 0);
        	if (! (numbytes >0) ) 
        	{
				on_disconnect_activate(0,0);
            	return -1;
        	}
    	}	
    	else
		{
			ret=send(s,msg,size, 0);
	        if (! (ret>0) )
        	{
				on_disconnect_activate(0,0);
            	return -1;
        	}
		}
    	return numbytes;
	}
	else
		return -1;
}
gchar* send_cmd(char *dir)
{

	 return _send_cmd(dir,main_sock);
}
gchar* _send_cmd(char *cmd,int sock)
{
    gchar *rec_send;
    gint  len=0;
    gchar *ret=0;
    gchar *old_ret=0;
  
  if(!sock)
  {
	  	show_error("Not Connected");
  		return g_strdup("");
  }
  if(!strstr(cmd,"status"))
  	myprint("send_cmd::cmd=%s",cmd);
  send_recv(sock,cmd,strlen(cmd),SEND);
  rec_send=g_malloc(4096);
  while(1)
  {
    int tmp_len=0;
    
    tmp_len=send_recv(sock,rec_send,4096,RECV);
    if(tmp_len>0)
		rec_send[tmp_len]='\0';
	else
		return g_strdup("");
		
    if(ret)
	{
		old_ret=ret;
		ret=g_strconcat(ret,rec_send,NULL);
		g_free(old_ret);
	}
    else
		ret=g_strdup(rec_send);
	
    if(strstr(ret,"OK\n") || (ret[0]=='A' && ret[1]=='C' && ret[2]=='K'))
    {
		g_free(rec_send);
        return ret;
    }  
  }
}
  
gchar *get_name_playing()
{
	gchar *fname;
	if(row_playing!=-1)
	{
		if(strlen(pl_array[row_playing].title)>0 && !prefs->onlyfn)
				fname=pl_array[row_playing].title;
		else
				fname=pl_array[row_playing].fname;
		return g_strdup_printf("%s - %s",
			  pl_array[row_playing].artist,
			  fname);
	}
	else
		return g_strdup("stopped");
}
struct file_info* parse_dir(gchar **line_tmp,gint file_count)
{
	gint  	  i=0;
	gint  	  file_index=-1;
	gchar     *str;
	gchar	  *path_tmp;
	gint	  len=0;
	struct file_info *array;

	array=g_malloc(sizeof(struct file_info)*file_count);
	
	/* Start data parsing */
	for(i=0;i<file_count;i++)
	{
		array[i].fields[0]=0;
		array[i].fields[1]=0;
		array[i].fields[2]=0;
		array[i].fields[3]=0;
		array[i].row=0;
	}
	i=0;
    while(line_tmp[i]!='\0' && file_index <= file_count)
    {	
	    if(line_tmp[i] && strstr(line_tmp[i],"file:"))
		{
			file_index++;
			path_tmp=line_tmp[i]+6;
			array[file_index].file_path=g_strdup(line_tmp[i]+6);//full path
			len=strlen(path_tmp);
			while(len-- && path_tmp[len]!='/');
			array[file_index].fname= g_convert (path_tmp+len+1,strlen(path_tmp+len+1), "UTF-8", "ISO-8859-1",NULL, NULL, NULL);

			len=0;
		}
	    if(line_tmp[i] && strstr(line_tmp[i],"Artist:"))
		{
			array[file_index].artist=g_convert(line_tmp[i]+7,strlen(line_tmp[i]+6),  "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
			array[file_index].fields[0]=1;
		}
	    if(line_tmp[i] && strstr(line_tmp[i],"Album:"))
		{
			array[file_index].album=g_convert(line_tmp[i]+6, strlen(line_tmp[i]+6), "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
			array[file_index].fields[1]=1;
		}
	    if(line_tmp[i] && strstr(line_tmp[i],"Track:"))
		{
			array[file_index].track=g_convert(line_tmp[i]+6,strlen(line_tmp[i]+6),  "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
			array[file_index].fields[2]=1;
		}
	    if(line_tmp[i] && strstr(line_tmp[i],"Title:"))
		{
			array[file_index].title=g_convert(line_tmp[i]+7,strlen(line_tmp[i]+7),  "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
			array[file_index].fields[3]=1;
		}
	    i++;
	}
	for(i=0;i<file_count;i++)
	{
		if(array[i].fields[0]==0)
				array[i].artist=g_strdup("");
		if(array[i].fields[1]==0)
				array[i].album=g_strdup("");
		if(array[i].fields[2]==0)
				array[i].track=g_strdup("");
		if(array[i].fields[3]==0)
				array[i].title=g_strdup("");
	}
	/* here we have array[] full of file data
 		and without nulls
	*/
	return array;
}
void make_dir(void) /*taken from xmms*/                                  
{                                                                               
        gchar *filename;                                                        
        filename = g_strconcat(g_get_home_dir(), "/.gtk2mp", NULL);            
        mkdir(filename, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);       
        g_free(filename);                                                       
                                                                                
}  
void read_config()
{
	gchar *filename;
	int   fd=0;
	struct stat bstat;
		
	filename = g_strconcat(g_get_home_dir(), "/.gtk2mp/config", NULL);
	if(stat(filename,&bstat)==0)
	{
		fd = InitConfig(filename);
    	SetGroup("Global",fd); /*[Global]*/
		prefs->server=GetString("Server",fd);
		prefs->songdisp=GetString("SongDisplayFormat",fd);
		prefs->port=GetNumber("Port",fd);
		prefs->refresh=GetNumber("Refresh",fd);
		prefs->auto_connect=GetNumber("AutoConnect",fd);
		prefs->onlyfn=GetNumber("OlyShowFileNames",fd);
		CloseConfig(filename, fd);
		g_free(filename);
	}
	if(prefs->refresh==0)
		prefs->refresh= 200;
	if(!prefs->server)
		prefs->server = g_strdup ("127.0.0.1");
	if(prefs->port==0)
		prefs->port = 2100;
	//prefs->auto_connect = 0;
	//prefs->onlyfn=0;
	if(prefs->songdisp==0)
		prefs->songdisp=g_strdup("");
}
void free_fileinfo(struct file_info *array, gint filecount)
{
	gint i=0;
	if(filecount && array)
	{
		for(i=0;i<filecount;i++)
		{
			g_free(array[i].album);
			g_free(array[i].artist);
			g_free(array[i].file_path);
			g_free(array[i].fname);
			g_free(array[i].title);
			g_free(array[i].track);
		}
		g_free(array);
	}
}

void save_config()
{
    FILE *useless;
	int fd;
	gchar *filename;
	
	filename = g_strconcat(g_get_home_dir(), "/.gtk2mp/config", NULL);         
    useless=fopen(filename,"w+");                                               
    fclose(useless);
	fd = InitConfig(filename);                                                  
    SetGroup("Global",fd); /*[Global]*/
	WriteString("Server",prefs->server,fd);
	WriteString("SongDisplayFormat",prefs->songdisp,fd);
	WriteNumber("Port",prefs->port,fd);
	WriteNumber("Refresh",prefs->refresh,fd);
	WriteNumber("AutoConnect",prefs->auto_connect,fd);
	WriteNumber("OlyShowFileNames",prefs->onlyfn,fd);
	
	CloseConfig(filename, fd);
}
gchar * append(gchar *dest, gchar *str)
{
		if(dest)
		{
			gchar *tmp;	
			tmp=dest;
			dest=g_strconcat(dest," ",str,NULL);
			g_free(tmp);
		}
		else
			dest=g_strdup(str);
		return dest;
}
gchar * getSongDisplay(gchar * config, struct file_info *fi) 
{
	char * temp=NULL;
	int i;
	if(strlen(config)>1)
	{
		for(i=0;i<strlen(config);i++) 
		{
			if(strncmp(&config[i],"%A",2)==0) {
				temp=append(temp,fi->album);
				i++;
			}
			else if(strncmp(&config[i],"%N",2)==0) {
				temp=append(temp,fi->track);
				i++;
			}
			else if(strncmp(&config[i],"%T",2)==0) {
				temp=append(temp,fi->title);
				i++;
			}
			else if(strncmp(&config[i],"%F",2)==0) {
				temp=append(temp,fi->fname);
				i++;
			}
			else if(strncmp(&config[i],"%P",2)==0) {
				temp=append(temp,fi->artist);
				i++;
			}
			else {
				gchar temp2[2];
				temp2[0] = config[i];
				temp2[1] = '\0';
				temp=append(temp,temp2);
			}
		}
		if(temp)
		{
			return temp;
		}
		else
			return g_strdup("Error displaying name, check config");
		
		
	}
	else	
		if(strlen(fi->title)>0 && !prefs->onlyfn)
				return g_strdup(fi->title);
			else
				return g_strdup(fi->fname);
}
void myprint(gchar * format, ... )
{
	
	va_list arglist;
	
	if(DEBUG==TRUE)
	{
		va_start(arglist,format);
		g_vprintf(format,arglist);
		va_end(arglist);
	}
	
}
gchar * mpd_sanitizePath(gchar * path) {
	gint i;
	gint count=0;
	gchar * ret;

	for(i=0;i<strlen(path);i++) {
		if(path[i]=='"' || path[i]=='\\') count++;
	}

	ret = g_malloc(strlen(path)+count+1);

	count = 0;
	for(i=0;i<strlen(path)+1;i++) {
		if(path[i]=='"' || path[i]=='\\') {
			ret[i+count] = '\\';
			count++;
		}
		ret[i+count] = path[i];
	}

	return ret;
}
/* End section of utility functions 

*/
void command_list_end()
{
	gchar *cmd;
	gchar *ret;
	cmd=g_strdup("command_list_end\n");
	ret=send_cmd(cmd);
	g_free(cmd);
		if(show_ret(ret))
			g_free(ret);
}

void command_list_begin()
{
	gchar *cmd;

	cmd=g_strdup("command_list_begin\n");
	send_recv(main_sock,cmd ,strlen(cmd),SEND);
	g_free(cmd);

}

void set_widget_prefs()
{
	GtkWidget *prefs_server;
	GtkWidget *prefs_port;
	GtkWidget *prefs_refresh;	
	GtkWidget *prefs_connect;
	GtkWidget *prefs_onlyfn;
	GtkWidget *prefs_songdisp;
	GtkAdjustment *adj;	
	
	prefs_server=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_server");
	prefs_songdisp=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_songdisp");
	prefs_port=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_port");
	prefs_refresh=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_refresh");
	prefs_connect=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_connect");
	prefs_onlyfn=lookup_widget (GTK_WIDGET(PrefsWindow),"prefs_onlyfn");
	gtk_entry_set_text(GTK_ENTRY(prefs_server),prefs->server);
	gtk_entry_set_text(GTK_ENTRY(prefs_songdisp),prefs->songdisp);
	gtk_entry_set_text(GTK_ENTRY(prefs_port),g_strdup_printf("%i",prefs->port));
	
	gtk_spin_button_set_value((GtkSpinButton*)prefs_refresh,prefs->refresh);
	gtk_toggle_button_set_active((GtkToggleButton *)prefs_connect,prefs->auto_connect);
	gtk_toggle_button_set_active((GtkToggleButton *)prefs_onlyfn,prefs->onlyfn);

}
void set_file_playing(gint row)
{
	GtkWidget	*text_view;
	GtkTextBuffer *buffer;
	GList *list;
	struct file_info *fi;
	gchar *song_display;
	
	text_view=lookup_widget (GTK_WIDGET(MainWindow),"file_playing_textview");
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
	if(row!=-1)
	{		
		list=g_list_find_custom(playlist_glist,(gpointer)row,(GCompareFunc)get_glistbyrow);
		if(list)
		{
			fi=(struct file_info*)list->data;
			
			/*if(strlen(fi->title)>0 && !prefs->onlyfn)
				gtk_text_buffer_set_text(buffer,fi->title,-1);
			else
				gtk_text_buffer_set_text(buffer,fi->fname,-1);*/
			song_display=getSongDisplay(prefs->songdisp,fi);
			gtk_text_buffer_set_text(buffer,song_display,-1);
			gtk_text_view_set_buffer((GtkTextView*)text_view,buffer);
		}
		set_clist_bg(playlist_clist,row,"#80f080");
	}
	else
	{
			buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
			gtk_text_buffer_set_text(buffer," ",-1);
			gtk_text_view_set_buffer((GtkTextView*)text_view,buffer);
	}
	if(row_playing!=row)
		set_clist_bg(playlist_clist,row_playing,"#ffffff");
	row_playing=row;
}

void fill_playlist()
{
	gchar 	  *ret;
	gint 	  i=0;
	gint 	  len=0;
	gint 	  line_len=0;
    gint 	  file_count=0;
	gchar 	  **line_tmp;
	gchar     *data_add[1];	
	GtkWidget *add_btn;
	GtkWidget *list_item;
	GtkWidget *image2;	
    GtkWidget *playlist_list;
  	GtkWidget *playlist_clist; 
	GtkWidget *label;
	struct file_info *array;
	

	playlist_clist	=lookup_widget (GTK_WIDGET(PlayBrowse), "playlist_clist");
	if(pl_filecount)
	{
		gtk_clist_clear ((GtkCList*)playlist_clist);
		g_list_free(playlist_glist);
		free_fileinfo(pl_array,pl_filecount);
		pl_filecount=0;
		playlist_glist=NULL;
	}
	
	ret=send_cmd("playlistinfo -1\n");
	if(!show_ret(ret))
		return;
	len=strlen(ret);
	
  for(i=0;i<len;i++)
	    if(ret[i]=='\n') line_len++;
    line_tmp=g_strsplit(ret,"\n",line_len);
    g_free(ret);
	i=0;
    while(line_tmp[i]!='\0')
    {	
		if(line_tmp[i] && strstr(line_tmp[i],"file:")) file_count++;
	    i++;		
    }

   	myprint("fill_playlist::playlist count=%i\n",file_count);		

	pl_filecount=file_count;
	if(file_count)
	{
		gtk_clist_freeze(GTK_CLIST(playlist_clist)); //freeze
		array=parse_dir(line_tmp,file_count);
		pl_array=array;
		for(i=0;i<file_count;i++)
		{
			/*if(strlen(array[i].title)>0 && !prefs->onlyfn)
				data_add[0]=array[i].title;
			else
				data_add[0]=array[i].fname;*/
			data_add[0]=getSongDisplay(prefs->songdisp,&array[i]);
  			gtk_clist_append ((GtkCList *)playlist_clist,data_add);
			array[i].row=(GTK_CLIST(playlist_clist)->rows)-1;
			playlist_glist=g_list_append(playlist_glist,&array[i]);
		}
		gtk_clist_thaw(GTK_CLIST(playlist_clist)); //thaw
	}
	g_strfreev(line_tmp);
}

void fill_files(struct file_info *array,gint file_count,gboolean file_or_search)
{
	gint  i=0;
	GtkWidget *add_btn;
	GtkWidget *list_item;
	GtkWidget *image2;
	GtkWidget   *files_list;
  	GtkWidget *files_clist;
	GtkWidget *label;
	gchar     *data_add[4];	
	/*we display the button add for the playlist
	  and set the default settings for the widgets
	*/

	if(file_or_search==TRUE)
  		files_clist		=lookup_widget (GTK_WIDGET(PlayBrowse), "files_clist");
	else
		files_clist		=lookup_widget (GTK_WIDGET(PlayBrowse), "search_clist");
	
	gtk_clist_freeze(GTK_CLIST(files_clist)); //freeze
	
	gtk_clist_clear ((GtkCList*)files_clist);
	//gtk_clist_set_column_auto_resize((GtkCList*)files_clist,0,TRUE);
	gtk_clist_set_sort_type((GtkCList*)files_clist,GTK_SORT_DESCENDING);

	for(i=0;i<file_count;i++)
	{
		if(strlen(array[i].title) && !prefs->onlyfn)
			data_add[0]=array[i].title;
		else
			data_add[0]=array[i].fname;
		data_add[1]=array[i].artist;
		data_add[2]=array[i].album;
		data_add[3]=array[i].track;
		
  		gtk_clist_append ((GtkCList *)files_clist,data_add);
		array[i].row=(GTK_CLIST(files_clist)->rows)-1;
		gtk_clist_set_row_data((GtkCList*)files_clist,array[i].row,&array[i]);
	}
	gtk_clist_thaw(GTK_CLIST(files_clist)); //thaw
}
void do_search(gchar *option,gchar *data)
{
	struct file_info *array;
	gchar *cmd;
	gchar *ret;
	gint len=0;
	gint line_len=0;
	gint i=0;
	gint file_count=0;
	gchar **line_tmp=NULL;
	gchar *data_safe;
	
	data_safe=mpd_sanitizePath(data);
	cmd=g_strdup_printf("search %s \"%s\"\n",option,data_safe);
	g_free(data_safe);
	ret=send_cmd(cmd);
	g_free(cmd);
	if(!show_ret(ret))
		return;
	len=strlen(ret);
	
	for(i=0;i<len;i++)
	    if(ret[i]=='\n') line_len++;
    line_tmp=g_strsplit(ret,"\n",line_len);
    g_free(ret);
    i=0;
    while(line_tmp[i]!='\0')
    {	
		if(line_tmp[i] && strstr(line_tmp[i],"file:")) file_count++;
	    i++;		
    }
	if(search_array!=NULL)
	{
		free_fileinfo(search_array,search_filecount);
		search_array=NULL;
		search_filecount=0;
	}
	array=parse_dir(line_tmp,file_count); //mem leak?
	search_array=array;
	search_filecount=file_count;
	fill_files(array,file_count,FALSE);
}
void fill_dir(gchar *dir)
{
    gchar *ret;
    gchar **line_tmp;
    gchar *str_tmp=NULL;
    gint len=0;
    gint i=0;
    gint line_len=0;
	gint file_count=0;
    struct widget_data *wid_data;
	GtkWidget *directory_clist;
    GtkWidget   *dir_list;	    
    GtkWidget *list_item;
    GtkWidget *label;
    GtkWidget *image;
    GtkWidget *add_btn;
	GtkWidget *label_directory;
	
	ret=send_cmd(dir);
	if(!show_ret(ret))
		return;
	len=strlen(ret);
	dir_list	=lookup_widget (GTK_WIDGET(PlayBrowse), "dir_list");
	directory_clist=lookup_widget (GTK_WIDGET(PlayBrowse), "directory_clist");
	label_directory =
		lookup_widget (GTK_WIDGET (PlayBrowse),
			       "label_directory");
	//FIXME: add delete of file_info struct
	gtk_clist_set_sort_type((GtkCList*)directory_clist,GTK_SORT_DESCENDING);
	gtk_list_clear_items((GtkList*)dir_list,0,-1);
	gtk_clist_clear ((GtkCList*)directory_clist);
    dir_rows=0;
	
	gtk_label_set_text(GTK_LABEL(label_directory),current_dir);
	
	//add ".."
	add_btn = gtk_button_new ();
	gtk_widget_show (add_btn);
	image = gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (image);
	gtk_container_add (GTK_CONTAINER (add_btn), image);
	list_item=gtk_list_item_new ();                                         
	gtk_container_add (GTK_CONTAINER (list_item), add_btn);
	gtk_widget_show (list_item);
	gtk_widget_show (add_btn);   
	gtk_container_add (GTK_CONTAINER (dir_list), list_item);
	
	wid_data=g_malloc(sizeof(struct widget_data));
	wid_data->data[0][0]=g_strdup("..");
	
	wid_data->path=g_strdup(parent_dir);
	gtk_clist_append ((GtkCList *)directory_clist,wid_data->data[0]);

	gtk_clist_set_row_data_full((GtkCList*)directory_clist,0,(gpointer*)wid_data,del_wid_data);
    //end add
  for(i=0;i<len;i++)
	    if(ret[i]=='\n') line_len++;
    line_tmp=g_strsplit(ret,"\n",line_len);
    g_free(ret);
    i=0;
    while(line_tmp[i]!='\0')
    {	
	    if(line_tmp[i] && strstr(line_tmp[i],"directory:"))
	    {
		    
		str_tmp=g_strrstr(line_tmp[i],"/");
		wid_data=g_malloc(sizeof(struct widget_data));
		wid_data->path=g_strdup(line_tmp[i]);
		if(str_tmp)
			wid_data->data[0][0]=g_convert (str_tmp+1,strlen(str_tmp+1), "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
		else
			wid_data->data[0][0]=g_convert (line_tmp[i]+11,strlen(line_tmp[i]+11), "UTF-8", "ISO-8859-1",NULL, NULL, NULL);
		    
		wid_data->add_btn = gtk_button_new ();
		wid_data->image = gtk_image_new_from_stock ("gtk-add", GTK_ICON_SIZE_BUTTON);
		gtk_widget_show (wid_data->image);
		gtk_container_add (GTK_CONTAINER (wid_data->add_btn), wid_data->image);
		wid_data->list_item=gtk_list_item_new ();                                         
		gtk_container_add (GTK_CONTAINER (wid_data->list_item), wid_data->add_btn);
		gtk_widget_show (wid_data->list_item);
		gtk_widget_show (wid_data->add_btn);   
		gtk_container_add (GTK_CONTAINER (dir_list), wid_data->list_item);
		g_signal_connect ((gpointer) wid_data->add_btn, "clicked",
                    			G_CALLBACK (dir_add_pl),
                    			wid_data->path+11);//MEM LEAK
		gtk_clist_append ((GtkCList *)directory_clist,wid_data->data[0]);
		dir_rows++;
		gtk_clist_set_row_data_full((GtkCList*)directory_clist,dir_rows,(gpointer*)wid_data,del_wid_data);
		}
		if(line_tmp[i] && strstr(line_tmp[i],"file:")) file_count++;
	    i++;		
    }
	// here we free the file_info struct for files
	// and set the new fi_array and fi_filecount
	free_fileinfo(fi_array,fi_filecount);
	fi_filecount=file_count;
	fi_array=parse_dir(line_tmp,file_count);
	//
    fill_files(fi_array,file_count,TRUE); 
	g_strfreev(line_tmp);
    return;
}
void free_savedpl(GList *list)
{
	GList *node;
	if(list)
	{
		 for (node = g_list_first (list); node != NULL; node = g_list_next (node))
			g_free(node->data);
		g_list_free (list);
	}
}
void fill_savedpl()
{
	gchar 	  *ret;
	gint 	  i=0;
	gint 	  len=0;
	gint 	  line_len=0;
    gint 	  file_count=0;
	gchar 	  **line_tmp;
	gchar     *data_add[1];	
  	GtkWidget *playlist_clist; 
	GList	  *node;
	

	playlist_clist	=lookup_widget (GTK_WIDGET(PlayBrowse), "savedpl_clist");

	gtk_clist_clear ((GtkCList*)playlist_clist);
	free_savedpl(savedpl_list);
	savedpl_filecount=0;
	savedpl_list=NULL;
	ret=send_cmd("lsinfo\n");
	if(!show_ret(ret))
		return;
	len=strlen(ret);
	
  for(i=0;i<len;i++)
	    if(ret[i]=='\n') line_len++;
    line_tmp=g_strsplit(ret,"\n",line_len);
    g_free(ret);
	i=0;
    while(line_tmp[i]!='\0')
    {	
		if(line_tmp[i] && strstr(line_tmp[i],"playlist:"))
		{	
			file_count++;
			savedpl_list = g_list_append (savedpl_list, g_strdup(line_tmp[i]+10));
		}
	    i++;		
    }

   	myprint("fill_playlist::file playlist count=%i\n",file_count);		

	savedpl_filecount=file_count;
	if(file_count)
	{
		i=0;
		gtk_clist_freeze(GTK_CLIST(playlist_clist)); //freeze
		for (node = g_list_first (savedpl_list); node != NULL; node = g_list_next (node))
    	{
			data_add[0]=node->data;
  			gtk_clist_append ((GtkCList *)playlist_clist,data_add);
			gtk_clist_set_row_data(GTK_CLIST(playlist_clist),i,node->data);
			i++;
		}
		gtk_clist_thaw(GTK_CLIST(playlist_clist)); //thaw
	}
	g_strfreev(line_tmp);
}
